codeforces 425C

题意:给定长度为n,m<=100000的范围在100000以内的数组a,b。

现在给定两种操作:

第一种是ai,bj相等,ai,bj之前的数全删掉,费用为e,收益为1

第二种是把剩下的全部删掉,花费为之前删除的数的个数,并且得到的之前的收益(也就是必须这一步,不然1的收益都无效)

思路:刚开始看错题意了。。以为第二种操作花费为剩下的个数。。

然后多写了一段。。。还wa了。。虽然思路差不多。。

那么题目等价与a,b数组中找到最多的不相交线段。。

但是单纯这样还是要跪。。注意到s/e<=300,那么就可以二维dp

f[i][j]表示做到a[i],有j对不相交线段的最近额b数组出现在什么位置。。

那么做法就很像不下降子序列nlogn版本的做法了。。

具体看代码吧。。

code:

 1 #include <bits/stdc++.h>
 2 using namespace std;
 3 #define vii vector<int>::iterator
 4 #define M0(a) memset(a, 0, sizeof(a))
 5 #define repf(i, a, b) for (int i = (a); i <= (b); ++i)
 6 int a[101010], b[101010], n, m, s, e;
 7 int f[301];
 8 vector<int> p[101010];
 9
10 void init(){
11     repf(i, 1, n) scanf("%d", &a[i]);
12     repf(i, 1, m) scanf("%d", &b[i]);
13     for (int i = 0; i <= 100000; ++i) p[i].clear();
14     repf(i, 1, m) p[b[i]].push_back(i);
15 }
16
17 void solve(){
18     int t = s / e;
19 //    cout << t << endl;
20     for (int i = 0; i <= t; ++i) f[i] = m+1;
21     f[0] = 0;
22     int ans = 0;
23     for (int i = 0; i < n; ++i){
24         for (int j = t; j >= 0; --j) if (f[j] <= m){
25                vii it = upper_bound(p[a[i+1]].begin(), p[a[i+1]].end(), f[j]);
26                if (it != p[a[i+1]].end()) f[j+1] = min(f[j+1], *it);
27         }
28         for (int j = 0; j <= t; ++j) if (f[j] <= m)
29              if (j * e + f[j] + i + 1 <= s) ans = max(ans, j);
30     }
31     cout << ans << endl;
32 }
33
34 int main(){
35 //    freopen("a.in", "r", stdin);
36     while (scanf("%d%d%d%d", &n, &m, &s, &e) != EOF){
37           init();
38           solve();
39     }
40 }

时间: 2024-09-29 19:38:48

codeforces 425C的相关文章

CodeForces 425C Sereja and Two Sequences

题意: 两组数字a和b  如果a[i]等于b[j]  则可将a[i]和b[j]前所有数字删掉  这种操作花费e体力  得到1元钱  或者一次删掉所有数字  这种操作花费等于曾经删除的所有数字个数  做完后得到所有钱  问 一共s体力 可以得到多少钱 思路: dp+二分 由数据可知最多拿到300元钱  因此可以定义  dp[i][j]表示有i元钱时  b串删除到了j处时  a串删到的位置 状态转移为 dp[i][j] = lower_bound ( a[j] , dp[i-1][j-1] + 1

【codeforces 718E】E. Matvey&#39;s Birthday

题目大意&链接: http://codeforces.com/problemset/problem/718/E 给一个长为n(n<=100 000)的只包含‘a’~‘h’8个字符的字符串s.两个位置i,j(i!=j)存在一条边,当且仅当|i-j|==1或s[i]==s[j].求这个无向图的直径,以及直径数量. 题解:  命题1:任意位置之间距离不会大于15. 证明:对于任意两个位置i,j之间,其所经过每种字符不会超过2个(因为相同字符会连边),所以i,j经过节点至多为16,也就意味着边数至多

Codeforces 124A - The number of positions

题目链接:http://codeforces.com/problemset/problem/124/A Petr stands in line of n people, but he doesn't know exactly which position he occupies. He can say that there are no less than a people standing in front of him and no more than b people standing b

Codeforces 841D Leha and another game about graph - 差分

Leha plays a computer game, where is on each level is given a connected graph with n vertices and m edges. Graph can contain multiple edges, but can not contain self loops. Each vertex has an integer di, which can be equal to 0, 1 or  - 1. To pass th

Codeforces Round #286 (Div. 1) A. Mr. Kitayuta, the Treasure Hunter DP

链接: http://codeforces.com/problemset/problem/506/A 题意: 给出30000个岛,有n个宝石分布在上面,第一步到d位置,每次走的距离与上一步的差距不大于1,问走完一路最多捡到多少块宝石. 题解: 容易想到DP,dp[i][j]表示到达 i 处,现在步长为 j 时最多收集到的财富,转移也不难,cnt[i]表示 i 处的财富. dp[i+step-1] = max(dp[i+step-1],dp[i][j]+cnt[i+step+1]) dp[i+st

Codeforces 772A Voltage Keepsake - 二分答案

You have n devices that you want to use simultaneously. The i-th device uses ai units of power per second. This usage is continuous. That is, in λ seconds, the device will use λ·ai units of power. The i-th device currently has bi units of power store

Educational Codeforces Round 21 G. Anthem of Berland(dp+kmp)

题目链接:Educational Codeforces Round 21 G. Anthem of Berland 题意: 给你两个字符串,第一个字符串包含问号,问号可以变成任意字符串. 问你第一个字符串最多包含多少个第二个字符串. 题解: 考虑dp[i][j],表示当前考虑到第一个串的第i位,已经匹配到第二个字符串的第j位. 这样的话复杂度为26*n*m*O(fail). fail可以用kmp进行预处理,将26个字母全部处理出来,这样复杂度就变成了26*n*m. 状态转移看代码(就是一个kmp

Codeforces Round #408 (Div. 2) B

Description Zane the wizard is going to perform a magic show shuffling the cups. There are n cups, numbered from 1 to n, placed along the x-axis on a table that has m holes on it. More precisely, cup i is on the table at the position x?=?i. The probl

Codeforces 617 E. XOR and Favorite Number

题目链接:http://codeforces.com/problemset/problem/617/E 一看这种区间查询的题目,考虑一下莫队. 如何${O(1)}$的修改和查询呢? 令${f(i,j)}$表示区间${\left [ l,r \right ]}$内数字的异或和. 那么:${f(l,r)=f(1,r)~~xor~~f(1,l-1)=k}$ 记一下前缀异或和即可维护. 1 #include<iostream> 2 #include<cstdio> 3 #include&l